/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   files.h : Dfinition des en-ttes de fichiers et des structures    *
 *             des enregistrements                                      *
 *                                                                      *
 ************************************************************************/

#ifndef FILES_H
#define FILES_H

#define ASG_HEADER "ASG 1.0 ANT Stratego Game    "
#define ASG_EOFILE " EOF .ASG"
#define ASH_HEADER "ASH 1.0 ANT Stratego History "
#define ASH_EOFILE " EOF .ASH"

struct TSavedGameEnreg {
/* Structure complte d'un fichier .ASG (sauvegarde d'une partie) */
     char szID[30];         // Header
     bool bAffichePrises;   // Inutilis
     bool bJoueurActuel;    // Joueur actuel au moment de la sauvegarde
     bool bComposer;        // Mode composer ou non
     int iNextElimine;      // Nombre de pions limins
     int iDeplacements;     // Nombre de dplacements (stats)
     int iVictoiresRouges;  // (stats)
     int iVictoiresBleues;  // (stats)
     int aiPions[10][10];   // Positions des pions sur le plateau de jeu
     int aiElimines[80];    // Pions limins
     char szEOF[10];        // Marque de fin de fichier
};
struct TDeplacement {
/* Structure d'un enregistrement d'un fichier .ASH (historique) */
     int iOld;      // Case de dpart
     int jOld;
     int iNew;      // Case d'arrive
     int jNew;
     int iCapture;  // Action  faire : dplacement ou capture
};

#endif
// FIN <Files.h> ===============================================================


