/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   unit3.cpp : Fentre principale                                     *
 *                                                                      *
 ************************************************************************/

#include <vcl.h>
#include <vcl\inifiles.hpp> // Objet "ini" (gestion d'un fichier .ini)
#include <string.h>

#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Unit5.h"
//#include "Unit7.h" // Jeu en rseau
#include "Unit9.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainWindow *MainWindow;

#define JOUEUR_ROUGE true
#define JOUEUR_BLEU false
//---------------------------------------------------------------------------
__fastcall TMainWindow::TMainWindow(TComponent* Owner) : TForm(Owner)
{
     /* Chargement des curseurs montrant le dplacement des pions */
     Screen->Cursors[1]=LoadCursorFromFile("res\\pion_rouge_1.cur");
     Screen->Cursors[2]=LoadCursorFromFile("res\\pion_rouge_2.cur");
     Screen->Cursors[3]=LoadCursorFromFile("res\\pion_rouge_3.cur");
     Screen->Cursors[4]=LoadCursorFromFile("res\\pion_rouge_4.cur");
     Screen->Cursors[5]=LoadCursorFromFile("res\\pion_rouge_5.cur");
     Screen->Cursors[6]=LoadCursorFromFile("res\\pion_rouge_6.cur");
     Screen->Cursors[7]=LoadCursorFromFile("res\\pion_rouge_7.cur");
     Screen->Cursors[8]=LoadCursorFromFile("res\\pion_rouge_8.cur");
     Screen->Cursors[9]=LoadCursorFromFile("res\\pion_rouge_9.cur");
     Screen->Cursors[10]=LoadCursorFromFile("res\\pion_rouge_espion.cur");
     Screen->Cursors[11]=LoadCursorFromFile("res\\pion_rouge_bombe.cur");
     Screen->Cursors[12]=LoadCursorFromFile("res\\pion_rouge_drapeau.cur");
     Screen->Cursors[13]=LoadCursorFromFile("res\\pion_rouge.cur");
     Screen->Cursors[14]=LoadCursorFromFile("res\\pion_bleu_1.cur");
     Screen->Cursors[15]=LoadCursorFromFile("res\\pion_bleu_2.cur");
     Screen->Cursors[16]=LoadCursorFromFile("res\\pion_bleu_3.cur");
     Screen->Cursors[17]=LoadCursorFromFile("res\\pion_bleu_4.cur");
     Screen->Cursors[18]=LoadCursorFromFile("res\\pion_bleu_5.cur");
     Screen->Cursors[19]=LoadCursorFromFile("res\\pion_bleu_6.cur");
     Screen->Cursors[20]=LoadCursorFromFile("res\\pion_bleu_7.cur");
     Screen->Cursors[21]=LoadCursorFromFile("res\\pion_bleu_8.cur");
     Screen->Cursors[22]=LoadCursorFromFile("res\\pion_bleu_9.cur");
     Screen->Cursors[23]=LoadCursorFromFile("res\\pion_bleu_espion.cur");
     Screen->Cursors[24]=LoadCursorFromFile("res\\pion_bleu_bombe.cur");
     Screen->Cursors[25]=LoadCursorFromFile("res\\pion_bleu_drapeau.cur");
     Screen->Cursors[26]=LoadCursorFromFile("res\\pion_bleu.cur");
     Screen->Cursors[27]=LoadCursor(HInstance,"CURSOR_HAND");
     Partie=NULL;
     /* Rcupration du rpertoire dans lequel se trouve le .exe de
          l'application, afin de pouvoir charger le .ini, les .bmp et le .hs */
     ASDirectory=ExtractFilePath(Application->ExeName);
     ODReplay->InitialDir=ASDirectory;
     SDReplay->InitialDir=ASDirectory;
     ODCharger->InitialDir=ASDirectory;
     SDSauver->InitialDir=ASDirectory;
     OptionsDLG->ChargeOptions();
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::M_QuitterClick(TObject *Sender)
{ // Fermeture de la fentre
     Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::M_OptionsClick(TObject *Sender)
{ // Options
     OptionsDLG->Change();
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::M_AboutClick(TObject *Sender)
{ //  propos de
     AboutDLG->ShowModal();
}
//---------------------------------------------------------------------------
bool __fastcall TMainWindow::QuitteProgramme()
{ /* Si on demande de fermer la fentre, il faut ventuellement demander 
     l'utilisateur s'il est sr de vouloir quitter (selon les options choisies)
    Renvoie false si on ne peut pas quitter, true si on peut */
     if(OptionsListe.bConfirmExit==true) {
          if(Application->MessageBox(
                    "Voulez-vous vraiment quitter `Ant Stratego ?","Quitter",
                    MB_YESNO|MB_ICONQUESTION)==IDYES) {
               if(Partie!=NULL) delete Partie;
               return true;
          }
          return false;
     } else {
          if(Partie!=NULL) delete Partie;
          return true;
     }
}

void __fastcall TMainWindow::M_ChargerClick(TObject *Sender)
{ // Ouvrir une partie
     ODCharger->InitialDir=ASDirectory;
     if(ODCharger->Execute()) {
          if(Partie!=NULL) delete Partie;
          Partie = new TPartie(ODCharger->FileName.c_str());
     }
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::M_SauverClick(TObject *Sender)
{ // Sauver une partie
     SDSauver->InitialDir=ASDirectory;
     if(SDSauver->Execute()) {
          if(!Partie->Save(SDSauver->FileName.c_str(),false)) {
               Application->MessageBox("Impossible d'crire le fichier de "
                    "sauvegarde : disque plein, protg en criture ou "
                    "rpertoire inexistant.","Erreur",MB_ICONSTOP);
          }
     }
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{ // On a tent de fermer la fentre (le programme ou l'utilisateur)
     CanClose=QuitteProgramme();
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::M_ReplayClick(TObject *Sender)
{ // Chargement d'un historique pour le replay
     if(ODReplay->Execute()) {
          if(Partie!=NULL) delete Partie;
          Partie=new TPartie(GetReplaySpeed(),ODReplay->FileName.c_str());
     }
}
//---------------------------------------------------------------------------
bool __fastcall TMainWindow::ChangeToolbarStyle(bool bStyle)
{ /* Changement de l'apparence de la barre d'outils */
  /* bStyle = true si boutons plats & texture, false si boutons normaux et
               pas de texture */
     switch(bStyle) {
          case true:
               ToolBar1->Height=26;
               break;
          case false:
               ToolBar1->Height=30;
     }
     ToolBar1->Flat=bStyle;
     ToolBar1->Transparent=bStyle;
     OptionsListe.bToolbarStyle=bStyle;
     return bStyle;
}

bool __fastcall TMainWindow::GetToolbarStyle()
{ // Renvoie le style de la barre d'outils
     return OptionsListe.bToolbarStyle;
}

void __fastcall TMainWindow::ChangeShowLogo(bool bShow)
{ /* bShow = true, il faut afficher le logo
           = false, il ne faut pas */
     OptionsListe.bShowLogo=bShow;
}

bool __fastcall TMainWindow::GetShowLogo()
{ // Faut-il afficher le logo
     return OptionsListe.bShowLogo;
}

void __fastcall TMainWindow::ChangeConfirmExit(bool bConfirm)
{ /* bConfirm = true s'il faut demander confirmation avant de quitter */
     OptionsListe.bConfirmExit=bConfirm;
}

bool __fastcall TMainWindow::GetConfirmExit()
{ // Faut-il demander confirmation
     return OptionsListe.bConfirmExit;
}

void __fastcall TMainWindow::ChangeReplayStyle(char cReplay,char *szReplayFile)
{ /* Change le choix du type d'enregistrement du replay */
     OptionsListe.cReplay=cReplay;
     if(szReplayFile!=NULL) strcpy(OptionsListe.szReplayFile,szReplayFile);
     else OptionsListe.szReplayFile[0]=0;
}

char __fastcall TMainWindow::GetReplayStyle(char **szFileName)
{ /* Faut-il ou non enregistrer l'historique, ainsi que le fichier o il
     faut l'enregistrer */
     if(szFileName!=NULL) {
          if(*szFileName!=NULL) delete *szFileName;
          *szFileName=new char[256];
          strcpy(*szFileName,OptionsListe.szReplayFile);
     }
     return OptionsListe.cReplay;
}
void __fastcall TMainWindow::ChangeReplaySpeed(int iSpeed)
{ // Changement de la vitesse du replay de l'historique
     OptionsListe.iReplaySpeed=iSpeed;
     TimerDepl->Interval=50*iSpeed+1;
}
int __fastcall TMainWindow::GetReplaySpeed()
{ // Vitesse du replay de l'historique
     return OptionsListe.iReplaySpeed;
}

void __fastcall TMainWindow::ChangeRecentrer(bool bRec)
{ /* Si bRec = true, il faut recentrer la fentre  chaque fois que sa taille
     change, sinon on la laisse  sa place */
     if(bRec) MainWindow->Position=poScreenCenter;
     OptionsListe.bRecentrer=bRec;
}

bool __fastcall TMainWindow::GetRecentrer()
{ // Faut-il recentrer la fentre
     return OptionsListe.bRecentrer;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::M_NouveauClick(TObject *Sender)
{ // Nouveau jeu local
     NouvellePartie();
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::NouvellePartie()
{ /* Cration d'une nouvelle partie */
     MainWindow->EnableStats(false);
     MainWindow->EnableSauver(false);
     if(Partie!=NULL) delete Partie;
     Partie=new TPartie();
}

void __fastcall TMainWindow::M_AideClick(TObject *Sender)
{ // Aide en ligne
     ShellExecute(0, NULL, "start", (ExtractFilePath(Application->ExeName)+"hlp\\index.html)").c_str(), NULL, SW_NORMAL);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::EnableStats(bool bEnabled)
{ // Bouton & menu permettant l'appel des statistiques
     B_Stats->Enabled=bEnabled;
     M_Stats->Enabled=bEnabled;
}
void __fastcall TMainWindow::EnableSauver(bool bEnabled)
{ /* Bouton & menu permettant de sauver : uniquement pendant l'cran
     intermdiaire */
     B_Sauver->Enabled=bEnabled;
     M_Sauver->Enabled=bEnabled;
}
void __fastcall TMainWindow::EnableReplayControl(bool bAut,bool bMan,
     bool bNext, bool bPaused)
{ /* Activer ou dsactiver les boutons permettant de contrler le replay
     de l'historique */
  /* bAut = bouton "replay automatique"
     bMan = bouton "replay manuel"
     bNext = bouton "dplacement suivant"
     bPaused = true si manuel, false si automatique */
     B_Manuel->Down=bPaused;
     M_Manuel->Checked=bPaused;
     B_Auto->Enabled=bAut;
     B_Manuel->Enabled=bMan;
     B_MovNext->Enabled=bNext;
     M_Auto->Enabled=bAut;
     M_Manuel->Enabled=bMan;
     M_MovNext->Enabled=bNext;
}

void __fastcall TMainWindow::BJoueurRougeClick(TObject *Sender)
{ // Clic sur "placer les pices rouges"
     Partie->RemoveChangeJoueur();
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::BJoueurBleuClick(TObject *Sender)
{ // Clic sur "placer les pices bleues"
     Partie->RemoveChangeJoueur();
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::BJoueurBleuOKClick(TObject *Sender)
{ // Clic sur "valider" (joueur Bleu)
     OKClick();
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::BJoueurRougeOKClick(TObject *Sender)
{ // Clic sur "valider" (joueur Rouge)
     OKClick();
}

void __fastcall TMainWindow::OKClick()
{ // Clic sur "valider"
     if(Partie->ValiderPieces()==false) {
          switch(Partie->GetComposer()) {
               case false : // Toutes les pices n'ont pas encore t places
                    if(Application->MessageBox("Toutes les pices n'ont pas t"
                              " places\nVoulez-vous placer automatiquement les"
                              " pices restantes ?",
                              "Question",MB_YESNO|MB_ICONQUESTION)==IDYES) {
                         Partie->PlacerPiecesAuto(true);
                              // Placement automatique
                    } else {
                         return;
                    }
                    break;
               case true : /* En mode "composer une partie ", seul le drapeau
                              doit absolument avoir t plac */
                    Application->MessageBox("Le drapeau n'a pas t plac",
                         "Message",MB_ICONEXCLAMATION);
                    return;
          }
     } else {
          Partie->PlacerPiecesOK(); // Valid
     }
     StatusBar1->SetTextBuf("");
     Partie->JoueurSuivant();
     if(Partie->GetComposer()==true) BCommencer->Click();
          // En mode "composer", on commence directement
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BJoueurRougeAutoClick(TObject *Sender)
{ // Placer automatiquement
     Partie->PlacerPiecesAuto(false);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BJoueurBleuAutoClick(TObject *Sender)
{ // Placer automatiquement
     Partie->PlacerPiecesAuto(false);

}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::EnableButtons(bool bVisible,
          bool bJoueur, bool bPlacer,bool bAuto,bool bValid,bool bGo)
{ /* Gestion de l'activation/dsactivation des boutons situs sous le plateau
     de jeu */
  /* bVisible = les boutons sont visibles
     bJoueur = joueur en cours (3 boutons diffrent d'aprs le joueur
     bPlacer = bouton "placer les pices"
     bAuto = bouton "placer automatiquement"
     bValid = bouton "valider"
     bGo = bouton "commencer" */
     BCommencer->Visible=bVisible;
     BCommencer->Enabled=bGo;
     if(bVisible==true) {
          switch(bJoueur) {
               case JOUEUR_ROUGE :
                    BJoueurRouge->Visible=bVisible;
                    BJoueurRougeOK->Visible=bVisible;
                    BJoueurRougeAuto->Visible=bVisible;
                    BJoueurBleu->Visible=!bVisible;
                    BJoueurBleuOK->Visible=!bVisible;
                    BJoueurBleuAuto->Visible=!bVisible;
                    BJoueurRouge->Enabled=bPlacer;
                    BJoueurRougeOK->Enabled=bValid;
                    BJoueurRougeAuto->Enabled=bAuto;
                    break;
               case JOUEUR_BLEU :
                    BJoueurRouge->Visible=!bVisible;
                    BJoueurRougeOK->Visible=!bVisible;
                    BJoueurRougeAuto->Visible=!bVisible;
                    BJoueurBleu->Visible=bVisible;
                    BJoueurBleuOK->Visible=bVisible;
                    BJoueurBleuAuto->Visible=bVisible;
                    BJoueurBleu->Enabled=bPlacer;
                    BJoueurBleuOK->Enabled=bValid;
                    BJoueurBleuAuto->Enabled=bAuto;
                    break;
          }
     } else {
          BJoueurRouge->Visible=bVisible;
          BJoueurRougeOK->Visible=bVisible;
          BJoueurRougeAuto->Visible=bVisible;
          BJoueurBleu->Visible=bVisible;
          BJoueurBleuOK->Visible=bVisible;
          BJoueurBleuAuto->Visible=bVisible;
     }
}

void __fastcall TMainWindow::BCommencerClick(TObject *Sender)
{ // Commencer la partie
     Partie->RemoveChangeJoueur();
}
//---------------------------------------------------------------------------



void __fastcall TMainWindow::M_StatsClick(TObject *Sender)
{ // Statistiques
     StatWindow->Show();
}
//---------------------------------------------------------------------------


void __fastcall TMainWindow::M_ReseauClick(TObject *Sender)
{ // Nouveau jeu rseau -- Non implant
//     if(ReseauWindow->ShowModal()!=mrCancel) {
//     }
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::M_ScoresClick(TObject *Sender)
{ // Tableau des scores
     HighscoresWindow->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::LoadError()
{ // Erreur lors du chargement d'un fichier (header invalide)
     Application->MessageBox("Format de fichier incorrect","Erreur",
          MB_ICONSTOP);
     EnableStats(false);
}

void __fastcall TMainWindow::M_MovNextClick(TObject *Sender)
{ // Dplacement suivant lors du replay
     if(Partie->NextMove()==false) {
          // Fin de fichier
          Application->MessageBox("Partie termine","Message",
               MB_OK|MB_ICONINFORMATION);
          EnableReplayControl(false,false,false,true);
     }
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::B_AutoClick(TObject *Sender)
{ // Replay automatique
     EnableReplayControl(true,true,false,false);
     TimerDepl->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::B_ManuelClick(TObject *Sender)
{ // Replay manuel
     EnableReplayControl(true,true,true,true);
     TimerDepl->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::TimerDeplTimer(TObject *Sender)
{ /* Fonction appele toutes les x milliseconds lorsque le timer est activ :
     utilis par le replay automatique */
     if(Partie->NextMove()==false) {
          // Fin de fichier
          TimerDepl->Enabled=false;
          Application->MessageBox("Partie termine","Message",
               MB_OK|MB_ICONINFORMATION);
          EnableReplayControl(false,false,false,true);
     }
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::M_ComposerClick(TObject *Sender)
{ // Composer une partie
     MainWindow->EnableStats(false);
     MainWindow->EnableSauver(false);
     if(Partie!=NULL) delete Partie;
     Partie=new TPartie(false);
     BJoueurRouge->Click();
}
//---------------------------------------------------------------------------




