/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   unit3.h : Fentre principale                                       *
 *                                                                      *
 ************************************************************************/

#ifndef Unit3H
#define Unit3H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Grids.hpp>
#include <Outline.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include "Pieces.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------
struct TOptionsListe {
     // Options
     bool bToolbarStyle;     // Look de la barre d'outils
     bool bShowLogo;         // Affichage du logo au dmarrage
     bool bConfirmExit;      // Confirmation lors de la sortie
     char cReplay;           // Type d'enregistrement de l'historique
     char szReplayFile[256]; // Fichier o enregistrer l'historique
     int iReplaySpeed;       // Vitesse du replay
     bool bRecentrer;        // Centrer la fentre automatiquement
};
class TMainWindow : public TForm
{
  __published:
     TMainMenu *MainMenu1;
     TMenuItem *M_Quitter;
     TToolBar *ToolBar1;
     TToolButton *B_Quitter;
     TImageList *ImageList1;
     TToolButton *B_Nouveau;
     TMenuItem *M_Jeu;
     TMenuItem *M_Nouveau;
     TMenuItem *M_Options;
     TToolButton *B_Options;
     TMenuItem *M_Aides;
     TMenuItem *M_About;
     TToolButton *B_About;
     TMenuItem *M_Charger;
     TMenuItem *M_Sauver;
     TMenuItem *M_Replays;
     TMenuItem *M_MovNext;
     TMenuItem *M_Auto;
     TMenuItem *M_Manuel;
     TMenuItem *M_Composer;
     TMenuItem *M_Aide;
     TMenuItem *M_Stats;
     TToolButton *B_Composer;
     TToolButton *B_Stats;
     TToolButton *ToolButton8;
     TToolButton *B_Charger;
     TToolButton *B_Sauver;
     TToolButton *B_Replay;
     TMenuItem *M_Replay;
     TToolButton *B_MovNext;
     TToolButton *B_Auto;
     TToolButton *B_Manuel;
     TToolButton *B_Aide;
     TOpenDialog *ODCharger;
     TSaveDialog *SDSauver;
     TOpenDialog *ODReplay;
     TBitBtn *BJoueurRouge;
     TBitBtn *BJoueurBleu;
     TBitBtn *BCommencer;
     TBitBtn *BJoueurRougeOK;
     TBitBtn *BJoueurBleuOK;
     TToolButton *ToolButton3;
     TMenuItem *M_Reseau;
     TToolButton *B_Reseau;
     TToolButton *B_Scores;
     TMenuItem *M_Scores;
     TStatusBar *StatusBar1;
     TTimer *TimerDepl;
     TSaveDialog *SDReplay;
     TBitBtn *BJoueurRougeAuto;
     TBitBtn *BJoueurBleuAuto;
     TCoolBar *CoolBar1;
     void __fastcall M_QuitterClick(TObject *Sender);
     void __fastcall M_OptionsClick(TObject *Sender);
     void __fastcall M_AboutClick(TObject *Sender);
     void __fastcall M_ChargerClick(TObject *Sender);
     void __fastcall M_SauverClick(TObject *Sender);
     void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
     void __fastcall M_ReplayClick(TObject *Sender);
     void __fastcall M_NouveauClick(TObject *Sender);
     void __fastcall M_AideClick(TObject *Sender);
     void __fastcall BJoueurRougeClick(TObject *Sender);
     void __fastcall BJoueurBleuClick(TObject *Sender);
     void __fastcall BJoueurBleuOKClick(TObject *Sender);
     void __fastcall BJoueurRougeOKClick(TObject *Sender);
     void __fastcall OKClick();
     void __fastcall BCommencerClick(TObject *Sender);
     void __fastcall M_StatsClick(TObject *Sender);
     void __fastcall M_ReseauClick(TObject *Sender);
     void __fastcall M_ScoresClick(TObject *Sender);
     void __fastcall M_MovNextClick(TObject *Sender);
     void __fastcall B_AutoClick(TObject *Sender);
     void __fastcall B_ManuelClick(TObject *Sender);
     void __fastcall TimerDeplTimer(TObject *Sender);
     void __fastcall BJoueurRougeAutoClick(TObject *Sender);
     void __fastcall BJoueurBleuAutoClick(TObject *Sender);
     void __fastcall M_ComposerClick(TObject *Sender);
  private:
     bool __fastcall TMainWindow::QuitteProgramme();
     void __fastcall TMainWindow::NouvellePartie();
     TOptionsListe OptionsListe; // Structure mmorisant les options
  public:
     AnsiString ASDirectory; /* Rpertoire o se trouve le .exe qui a servi
                                    dmarrer le programme */
     __fastcall TMainWindow(TComponent* Owner);
     void __fastcall EnableStats(bool);
     void __fastcall EnableSauver(bool);
     void __fastcall EnableReplay(bool);
     void __fastcall EnableButtons(bool,bool,bool,bool,bool,bool);
     void __fastcall EnableReplayControl(bool,bool,bool,bool);
     bool __fastcall ChangeToolbarStyle(bool);
     void __fastcall ChangeShowLogo(bool);
     void __fastcall ChangeConfirmExit(bool);
     void __fastcall ChangeReplaySpeed(int);
     void __fastcall ChangeReplayStyle(char,char *);
     void __fastcall ChangeRecentrer(bool);
     bool __fastcall GetToolbarStyle();
     bool __fastcall GetShowLogo();
     bool __fastcall GetConfirmExit();
     int __fastcall GetReplaySpeed();
     bool __fastcall GetRecentrer();
     char __fastcall TMainWindow::GetReplayStyle(char **szFileName);
     void __fastcall LoadError();
     TPartie *Partie;  // Partie -> Plateau -> Pions
};
//---------------------------------------------------------------------------
extern PACKAGE TMainWindow *MainWindow;
//---------------------------------------------------------------------------


#endif
