/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   unit5.cpp : Statistiques de la partie                              *
 *                                                                      *
 ************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include "Unit5.h"
#include "Unit3.h"
#include <string.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TStatWindow *StatWindow;

extern char szPionFileNames[27][30]; // dans Pieces.cpp
char szPionNoms[12][16]={
     // Libells des pions
     "Marchaux [1]",
     "Gnraux [2]",
     "Colonels [3]",
     "Commandants [4]",
     "Capitaines [5]",
     "Lieutenants [6]",
     "Sergents [7]",
     "Dmineurs [8]",
     "claireurs [9]",
     "Espions",
     "Bombes",
     "Drapeaux"
     };
//---------------------------------------------------------------------------
__fastcall TStatWindow::TStatWindow(TComponent* Owner)
     : TForm(Owner)
{
     iDeplacements=0;
     iVictoiresRouges=0;
     iVictoiresBleues=0;
}
//---------------------------------------------------------------------------
void __fastcall TStatWindow::AddDeplacement()
{ // Appel depuis l'extrieur  chaque dplacement
     iDeplacements++;
}
void __fastcall TStatWindow::AddVictoire(int bCouleur)
{ // Appel depuis l'extrieur  chaque combat
     switch(bCouleur) {
          case PION_ROUGE : iVictoiresRouges++; break;
          case PION_BLEU  : iVictoiresBleues++; break;
     }
}

void __fastcall TStatWindow::ComptePieces()
{ /* Fait le compte des pices restantes et des pices limines, ces nombres
     tant rangs dans un tableau */
     int i,j;
     for(j=0;j<12;j++) {
          for(i=0;i<6;i++) {
               aiPieces[i][j]=0;
          }
     }
     MainWindow->Partie->ComptePieces(aiPieces);
          // D'ici on ne sait pas atteindre les pices
     TListItem *LI;
     int Totaux[6]={0,0,0,0,0,0};
     for(i=0;i<12;i++)
     { /* Ajout des nombres du tableaux dans la liste */
          LI=ListView1->Items->Add();
          LI->Caption=szPionNoms[i];
          for(j=0;j<6;j++) {
               LI->SubItems->Add(aiPieces[j][i]);
               Totaux[j]+=aiPieces[j][i];
          }
     }
     LI=ListView1->Items->Add();
     LI->Caption=">> Total";
     for(i=0;i<6;i++) {
          LI->SubItems->Add(Totaux[i]);
     }

}
//---------------------------------------------------------------------------
void __fastcall TStatWindow::FormShow(TObject *Sender)
{ /* Affichage de la fentre : il faut supprimer le contenu de l'ancienne liste
     avant de rcrire les informations dedans */
     for(int n=ListView1->Items->Count;n;n--) {
          ListView1->Items->Delete(0);
     }
     ComptePieces();
     char szBuf[10];
     sprintf(szBuf,"%i",iDeplacements);
     LDeplacements->SetTextBuf(szBuf);
     sprintf(szBuf,"%i",iVictoiresRouges);
     LVictoiresRouges->SetTextBuf(szBuf);
     sprintf(szBuf,"%i",iVictoiresBleues);
     LVictoiresBleues->SetTextBuf(szBuf);
}
//---------------------------------------------------------------------------
void __fastcall TStatWindow::B_FermerClick(TObject *Sender)
{
     this->Close();
}
//---------------------------------------------------------------------------
void __fastcall TStatWindow::ListView1SelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{ /* Lorsque le curseur passe sur une ligne de la liste, on affiche l'icne
     du pion dans le bas de la fentre */
     SetCurrentDir(MainWindow->ASDirectory);
     if(Selected==true) {
          if(Item->Index<12) {
               Image1->Picture->LoadFromFile(szPionFileNames[Item->Index+1]);
               Image2->Picture->LoadFromFile(szPionFileNames[Item->Index+14]);
          }
     } else {
          Image1->Picture->LoadFromFile(szPionFileNames[0]);
          Image2->Picture->LoadFromFile(szPionFileNames[0]);
     }
}
//---------------------------------------------------------------------------
void __fastcall TStatWindow::B_RefreshClick(TObject *Sender)
{ /* Refraichissement des infos contenues dans la fentre */
     SetCurrentDir(MainWindow->ASDirectory);
     Image1->Picture->LoadFromFile(szPionFileNames[0]);
     Image2->Picture->LoadFromFile(szPionFileNames[0]);
     for(int n=ListView1->Items->Count;n;n--) {
          ListView1->Items->Delete(0);
     }
     ComptePieces();
     char szBuf[10];
     sprintf(szBuf,"%i",iDeplacements);
     LDeplacements->SetTextBuf(szBuf);
     sprintf(szBuf,"%i",iVictoiresRouges);
     LVictoiresRouges->SetTextBuf(szBuf);
     sprintf(szBuf,"%i",iVictoiresBleues);
     LVictoiresBleues->SetTextBuf(szBuf);
}
//---------------------------------------------------------------------------
int __fastcall TStatWindow::GetDeplacements()
{ // Nombre de dplacements (sauver une partie)
     return iDeplacements;
}
int __fastcall TStatWindow::GetVictoires(int iCouleur)
{ // Nombre de victoires (sauver une partie)
     switch(iCouleur) {
          case PION_ROUGE : return iVictoiresRouges;
          case PION_BLEU : return iVictoiresBleues;
     }
     return 0;
}
void __fastcall TStatWindow::SetDeplacements(int iDepl)
{ // Initialisation du nombre de dplacements (charger une partie)
     iDeplacements=iDepl;
}
void __fastcall TStatWindow::SetVictoires(int iRouges, int iBleues)
{ // Initialisation du nombre de victoires (charger une partie)
     iVictoiresRouges=iRouges;
     iVictoiresBleues=iBleues;
}

// FIN <Unit5.cpp> =============================================================

