/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   unit5.h : Statistiques de la partie                                *
 *                                                                      *
 ************************************************************************/

#ifndef Unit5H
#define Unit5H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
#define PION_ROUGE 1
#define PION_BLEU 2

class TStatWindow : public TForm
{
  __published:
     TBitBtn *B_Fermer;
     TListView *ListView1;
     TBitBtn *B_Refresh;
     TPanel *Panel1;
     TLabel *Label7;
     TLabel *Label1;
     TLabel *Label2;
     TLabel *LDeplacements;
     TLabel *LVictoiresRouges;
     TLabel *LVictoiresBleues;
     TPanel *Panel2;
     TImage *Image1;
     TImage *Image2;
     void __fastcall FormShow(TObject *Sender);
     void __fastcall B_FermerClick(TObject *Sender);
     void __fastcall ListView1SelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
     void __fastcall B_RefreshClick(TObject *Sender);
  private:
     int aiPieces[6][12];  // Statistiques
     int iDeplacements;    // Nombre de dplacements
     int iVictoiresRouges; // Nombre de victoires
     int iVictoiresBleues;
  public:
     __fastcall TStatWindow(TComponent* Owner);
     void __fastcall AddDeplacement();
     void __fastcall AddVictoire(int);
     void __fastcall ComptePieces();
     int __fastcall GetDeplacements();
     int __fastcall GetVictoires(int);
     void __fastcall SetDeplacements(int);
     void __fastcall SetVictoires(int, int);
};
//---------------------------------------------------------------------------
extern PACKAGE TStatWindow *StatWindow;
//------------------------------------------------------------------------------
#endif
// FIN <Unit5.h> ===============================================================
