/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   unit8.cpp : Fin de partie                                          *
 *                                                                      *
 ************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include "Unit8.h"
#include "Unit5.h"
#include "Unit9.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TVainqueurWindow *VainqueurWindow;

extern char szPionFileNames[27][30];   // dans Pieces.cpp
extern char szPionDescription[27][30]; // dans Pieces.cpp

//---------------------------------------------------------------------------
__fastcall TVainqueurWindow::TVainqueurWindow(TComponent* Owner)
     : TForm(Owner)
{
     iGagnant=0;
}
//---------------------------------------------------------------------------
void __fastcall TVainqueurWindow::Victoire(int iVainqueur,int iDrapeau)
{ /* Affichage du vainqueur */
     SetCurrentDir(MainWindow->ASDirectory);
     LUnite->SetTextBuf(szPionDescription[iVainqueur]);
     PUnite->Picture->LoadFromFile(szPionFileNames[iVainqueur]);
     LDrapeau->SetTextBuf(szPionDescription[iDrapeau]);
     PDrapeau->Picture->LoadFromFile(szPionFileNames[iDrapeau]);
     switch(iDrapeau) {
          case 12:
               iGagnant=PION_BLEU;
               LVainqueur->SetTextBuf("Joueur bleu");
               PVainqueur->Picture->LoadFromFile(szPionFileNames[26]);
               break;
          case 25:
               iGagnant=PION_ROUGE;
               LVainqueur->SetTextBuf("Joueur rouge");
               PVainqueur->Picture->LoadFromFile(szPionFileNames[13]);
               break;
     }
}

void __fastcall TVainqueurWindow::BStatClick(TObject *Sender)
{ // Affichage des statistiques
     StatWindow->Show();
}
//---------------------------------------------------------------------------
void __fastcall TVainqueurWindow::BScoresClick(TObject *Sender)
{ // Tableau des scores
     switch(bScoreEntre) {
          case false:
               // On ne peut entrer son nom qu'une seule fois
               bScoreEntre=true;
               HighscoresWindow->AddScore(StatWindow->GetDeplacements(),
                    StatWindow->GetVictoires(iGagnant));
                    /* On prvient la fentres des scores que le joueur peut
                         entrer son nom */
               break;
          case true:
               HighscoresWindow->ShowModal();
               break;
     }
}
//---------------------------------------------------------------------------

void __fastcall TVainqueurWindow::FormShow(TObject *Sender)
{
     bScoreEntre=false;
}
//---------------------------------------------------------------------------
// FIN <Unit8.cpp> =============================================================
