/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   unit9.cpp : Tableau des scores                                     *
 *                                                                      *
 ************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include "Unit9.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>

THighscoresWindow *HighscoresWindow;
//---------------------------------------------------------------------------
__fastcall THighscoresWindow::THighscoresWindow(TComponent* Owner)
     : TForm(Owner)
{
}

void __fastcall THighscoresWindow::AddScore(int iDeplacements, int iVictoires)
{ /* On "prvient" la fentre que le joueur pourra entrer son nom dans la
     table des scores */
  /* iDeplacements = Nombre de dplacements dont le joueur a eu besoin
     iVictoires = Nombre de victoires dont le joueur a eu besoin */
     ENom->Enabled=true;
     BAjouter->Enabled=true;
     iDepl=iDeplacements;
     iVict=iVictoires;
     ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall THighscoresWindow::FormShow(TObject *Sender)
{ /* Affichage de la fentre : on va chercher les scores dans le fichier */
     LitFichier();
}

//---------------------------------------------------------------------------

void __fastcall THighscoresWindow::LitFichier()
{ /* Lecture du fichier contenant les noms  afficher dans le tableau,
     et mise  jour de la liste */
     SetCurrentDir(MainWindow->ASDirectory);
     TEnreg strEnreg;
     TListItem *LI;
     int f=open("ant_stratego.hs",O_RDWR|O_CREAT,S_IREAD|S_IWRITE);
     if(f==-1) {
          Application->MessageBox("Impossible d'ouvrir le fichier ou "
               "de le crer","Erreur",MB_ICONSTOP);
          return;
     }
     for(int n=ListView1->Items->Count;n;n--) {
          ListView1->Items->Delete(0);
     }
     int iRead=read(f,(void *)&strEnreg,sizeof(strEnreg));
     while(iRead>0) {
          LI=ListView1->Items->Add();
          LI->Caption=strEnreg.szNom;
          LI->SubItems->Add(strEnreg.iDepl);
          LI->SubItems->Add(strEnreg.iVict);
          iRead=read(f,(void *)&strEnreg,sizeof(strEnreg));
     }
     close(f);
}
void __fastcall THighscoresWindow::BAjouterClick(TObject *Sender)
{ /* Ajout d'un nom dans le fichier des scores */
     SetCurrentDir(MainWindow->ASDirectory);
     BAjouter->Enabled=false;
     ENom->Enabled=false;
     TEnreg strEnreg;
     memset(strEnreg.szNom,' ',sizeof(strEnreg.szNom));
     ENom->GetTextBuf(strEnreg.szNom,sizeof(strEnreg.szNom)-1);
     strEnreg.iDepl=iDepl;
     strEnreg.iVict=iVict;
     int f=open("ant_stratego.hs",O_WRONLY|O_CREAT|O_APPEND);
     if(f==-1) {
          Application->MessageBox("Impossible d'ouvrir le fichier en criture",
               "Erreur",MB_ICONSTOP);
          return;
     }
     write(f,(void *)&strEnreg,sizeof(strEnreg));
     close(f);
     LitFichier(); // Actualisation de la liste
}
//---------------------------------------------------------------------------

void __fastcall THighscoresWindow::ListView1ColumnClick(TObject *Sender,
      TListColumn *Column)
{ // Tri lorsque l'on clique sur le titre d'une colonne de la liste
     ColumnToSort = Column->Index;
     ((TCustomListView *)Sender)->AlphaSort();
}
//---------------------------------------------------------------------------

void __fastcall THighscoresWindow::ListView1Compare(TObject *Sender,
      TListItem *Item1, TListItem *Item2, int Data, int &Compare)
{ /* Tri lorsque l'on clique sur le titre d'une colonne de la liste
     (ne fonctionne pas trs bien ...) */
     if (ColumnToSort == 0)
          Compare = CompareText(Item1->Caption,Item2->Caption);
     else
          Compare = CompareText(Item1->SubItems->GetText(),
               Item2->SubItems->GetText());
}
//---------------------------------------------------------------------------

void __fastcall THighscoresWindow::BDeleteClick(TObject *Sender)
{ /* Suppression du tableau des scores */
     if(Application->MessageBox("Ceci effacera le tableau de scores ainsi que"
               " le fichier dans lequel ils sont mmoriss.\ntes-vous sr ?",
               "Effacer les scores",MB_ICONQUESTION|MB_YESNO)==IDYES) {
          int f=open(ChangeFileExt(Application->ExeName,".hs").c_str(),
               O_RDWR|O_TRUNC|O_CREAT,S_IREAD|S_IWRITE);
          if(f==-1) {
               Application->MessageBox("Impossible de supprimer le fichier",
                    "Erreur",MB_ICONSTOP);
          } else {
               close(f);
               LitFichier();
          }
     }
}
//---------------------------------------------------------------------------
// FIN <Unit9.cpp> =============================================================
