/************************************************************************
 *                                                                      *
 *   Ant Stratego                                                       *
 *   (C) 2000 Antoine Potten                                            *
 *   software@antp.be - http://www.antp.be/software                     *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 2     *
 *   of the License, or (at your option) any later version.             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 *   unit9.h : Tableau des scores                                       *
 *                                                                      *
 ************************************************************************/

#ifndef Unit9H
#define Unit9H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
struct TEnreg {
     // Structure d'un enregistrement du fichier
     char szNom[52];  // Nom
     int iDepl;       // Nombre de dplacements
     int iVict;       // Nombre de victoires
};

class THighscoresWindow : public TForm
{
  __published:
     TListView *ListView1;
     TBitBtn *BFermer;
     TBitBtn *BAjouter;
     TGroupBox *GroupBox1;
     TEdit *ENom;
     TBitBtn *BDelete;
     void __fastcall FormShow(TObject *Sender);
     void __fastcall LitFichier();
     void __fastcall BAjouterClick(TObject *Sender);
     void __fastcall ListView1ColumnClick(TObject *Sender,
          TListColumn *Column);
     void __fastcall ListView1Compare(TObject *Sender, TListItem *Item1,
          TListItem *Item2, int Data, int &Compare);
     void __fastcall BDeleteClick(TObject *Sender);
  private:
     int iDepl;
     int iVict;
     int ColumnToSort;
  public:
     __fastcall THighscoresWindow(TComponent* Owner);
     void __fastcall AddScore(int,int);
};
//---------------------------------------------------------------------------
extern PACKAGE THighscoresWindow *HighscoresWindow;
//---------------------------------------------------------------------------
#endif
// FIN <Unit9.h> ===============================================================

